package findmostcommonarray;

import java.io.File;
import java.util.Scanner;

public class FindMostCommonArray {

    public static int[] readNumbers(String fileName) {
        Scanner input = null;
        try {
            input = new Scanner(new File(fileName));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        // We need to count the number of numbers first. We will read
        // through the file once simply to count how many numbers are
        // there...
        int N = 0;
        while (input.hasNextInt()) {
            int unused = input.nextInt();
            N++;
        }
        input.close();

        // Once we know how many numbers are in the file we can create an
        // array to hold them.
        int[] A = new int[N];

        // Now we have to read through the file again to put the numbers
        // into the array.
        try {
            input = new Scanner(new File(fileName));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        int n = 0; // Where the next number will go.
        while (input.hasNextInt()) {
            A[n] = input.nextInt();
            n++;
        }
        input.close();

        return A;
    }

    public static int findSmallest(int A[]) {
        int smallest = A[0];

        for (int n = 1; n < A.length; n++) {
            if (A[n] < smallest) {
                smallest = A[n];
            }
        }

        return smallest;
    }

    public static int findLargest(int A[]) {
        int largest = A[0];

        for (int n = 1; n < A.length; n++) {
            if (A[n] > largest) {
                largest = A[n];
            }
        }
        return largest;
    }

    public static int countNumber(int A[], int x) {
        int count = 0;

        for (int n = 0; n < A.length; n++) {
            if (A[n] == x) {
                count++;
            }
        }

        return count;
    }

    public static void main(String[] args) {

        int numbers[] = readNumbers("numbers.txt");

        // Find the smallest and largest numbers in the array
        int smallest = findSmallest(numbers);
        int largest = findLargest(numbers);

        int greatestCount = 0;
        int mostCommonNumber = 0;

        for (int x = smallest; x <= largest; x++) {
            // Count how many times x appears.
            int count = countNumber(numbers, x);

            // Check to see if this is the most common number.
            if (count > greatestCount) {
                greatestCount = count;
                mostCommonNumber = x;
            }
        }

        // Print the results
        System.out.println("The number " + mostCommonNumber + " appears most often.");
        System.out.println("It appears " + greatestCount + " times in the file.");
    }
}
